package com.jiayue.simulation.nettyice102.codec;

import com.jiayue.simulation.util.ByteUtil;
import com.jiayue.simulation.util.IEC102Uitl;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.ByteBufUtil;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

import java.net.InetSocketAddress;
import java.util.ArrayList;
import java.util.List;

/**
 * 解码器
 *
 */
@Slf4j
public class NettyDecoder extends SimpleChannelInboundHandler {
    //记录上次未读完的字节
    List<String> messageList = new ArrayList<String>();


    @Override
    protected void channelRead0(ChannelHandlerContext ctx, Object msg) throws Exception {
        InetSocketAddress insocket = (InetSocketAddress) ctx.channel().remoteAddress();
        // 获取远程IP
        String remoteIP = insocket.getAddress().getHostAddress();
        // 本地IP和端口
        InetSocketAddress localAddress = (InetSocketAddress) ctx.channel().localAddress();
        String localIp = localAddress.getAddress().getHostAddress();
        String localPort = String.valueOf(localAddress.getPort());

        try {
            ByteBuf buf = (ByteBuf) msg;
            String receiveStr = ByteBufUtil.hexDump(buf).toUpperCase();
            List<String> receivesList = IEC102Uitl.stingToList(receiveStr);
            messageList.addAll(receivesList);

            // 至少6个以上字节才报文解码
            if (messageList.size() >= 6) {
//                if (messageList.size()>300){
//                    // 没用的太多了，舍弃掉
////                    uploadLogger.info("没用字符串报文超过300个舍弃掉："+messageList.toString());
//                    messageList.clear();
//                }
//                else{
                    int zb = 0;
                    while (true) {
                        String nextMessage = "";
                        for (int k = 0; k < messageList.size(); k++) {
                            if ("10".equals(messageList.get(k)) && (k + 5) <= messageList.size() && messageList.get(k + 5).equals("16")) {
                                List newList = messageList.subList(k, (k + 6));
                                nextMessage = String.join("", newList);
                                String tempStr = String.join("", messageList).substring((k + 6) * 2);
                                messageList.clear();
                                messageList = IEC102Uitl.stingToList(tempStr);
                                break;
                            }
                            if ("68".equals(messageList.get(k)) && (k + 3) <= messageList.size() && messageList.get(k + 3).equals("68")) {
                                int tempLength = ByteUtil.hexToDec(messageList.get(k + 2) + messageList.get(k + 1));
                                int end16 = (k + 3) + tempLength + 2;
                                if (end16 <= messageList.size() && messageList.get(end16).equals("16")) {
                                    List newList = messageList.subList(k, (end16 + 1));
                                    nextMessage = String.join("", newList);
                                    String tempStr = String.join("", messageList).substring((end16 + 1) * 2);
                                    messageList.clear();
                                    messageList = IEC102Uitl.stingToList(tempStr);
                                    break;
                                }
                            }
                        }
                        if (!"".equals(nextMessage)) {
                            if (zb==1){
//                                uploadLogger.info("获取到粘包帧："+nextMessage);
                            }
                            zb++;
                            ctx.fireChannelRead(nextMessage);
                        }
                        else {
                            break;
                        }
                    }
                }
//            }
        }
        catch (Exception e){
            log.error("解码失败",e);
        }
    }
}
