package com.jiayue.simulation.nettyice102.service;

import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

@Slf4j
public abstract class NettyCommonService {


    /**
     *
     * @param messageStr 报文
     * @param fileNameLength 文件名称长度
     * @param charset 字符集
     * @param filePath 文件路径
     * @throws IOException  io异常
     */
    public void generateFile(String messageStr,Integer fileNameLength,String charset,String filePath) throws IOException {
//        // 报文用逗号分隔
//        String messageStr = "";
//        // 文件名称长度
//        Integer fileNameLength = 64;
//        // 生成文件编码格式
//        String charset = "GBK";
        messageStr = messageStr.replace(" ", "");
        String[] tempMessage = messageStr.split(",");
        String fileNameHex = "";
        StringBuilder sb = new StringBuilder("");
        for (String m : tempMessage) {
            // 循环每一帧的报文
            // 获取文件内容帧
            if ("".equals(fileNameHex)) {
                fileNameHex = m.substring(26, 26 + fileNameLength * 2);
            }
            // 拼接文件内容
            sb.append(m.substring(26 + fileNameLength * 2, m.length() - 4));
        }
        // 文件名去掉尾部占位的0
        fileNameHex = fileNameHex.replaceAll("0*$", "");
        int fileNameHexLength = fileNameHex.length();
        byte[] fnData = new byte[fileNameHexLength / 2];
        for (
                int k = 0;
                k < fileNameHexLength; k += 2) {
            fnData[k / 2] = (byte) ((Character.digit(fileNameHex.charAt(k), 16) << 4)
                    + Character.digit(fileNameHex.charAt(k + 1), 16));
        }
        String filename = new String(fnData, charset);
        // 生成文件内容
        String contentStr = sb.toString();
        int fileContentHexLength = contentStr.length();
        byte[] data = new byte[fileContentHexLength / 2];
        for (
                int i = 0;
                i < fileContentHexLength; i += 2) {
            data[i / 2] = (byte) ((Character.digit(contentStr.charAt(i), 16) << 4)
                    + Character.digit(contentStr.charAt(i + 1), 16));
        }


        String pathName = filePath + filename;
        File file = new File(pathName);
        OutputStreamWriter osw = null;
        if(!file.exists()){
            boolean hasFile = file.createNewFile();
            if(!hasFile){
                log.error("报文生成文件业务，文件创建失败：{}",pathName);
            }

            osw = new OutputStreamWriter(new FileOutputStream(file), charset);
        }else {
            osw = new OutputStreamWriter(new FileOutputStream(file,true), charset);
        }


        String res = new String(data, charset);
        osw.write(res);
        osw.close();


    }
}
